package com.Exception.main;

import java.awt.Dimension;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.JSplitPane;
import javax.swing.JTree;
import javax.swing.JScrollPane;
import javax.swing.JEditorPane;
import javax.swing.UIManager;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import java.io.IOException;
import java.net.URL;


class test implements TreeSelectionListener{
  //Fields
  JFrame frame;
  JPanel panel;
  JSplitPane split;
  JTree tree;
  JScrollPane scrollTop;
  JScrollPane scrollBottom;
  JEditorPane editorPane;
  
  //Constructor
  public test(){
    JFrame.setDefaultLookAndFeelDecorated(false);
    frame        = new JFrame("Tree^^");
    panel        = new JPanel();
    split        = new JSplitPane();
    tree         = new JTree(getTree());
    scrollTop    = new JScrollPane();
    scrollBottom = new JScrollPane();
    editorPane   = new JEditorPane();
    
    setComponents();
    addComponents();
    addWidget();
    viewUI();
  }
  
  public void setComponents(){
    //JFrame
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//    frame.setPreferredSize(new Dimension(500, 350));
    frame.setSize(new Dimension(500, 350));
    //JTree
    tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    
    //JEditorPane
    try{ editorPane.setPage( test.class.getResource("test.html")); }catch(IOException ie){ ie.getMessage(); }
    editorPane.setEditable(false);
    //JScrollPane
    scrollTop.setViewportView(tree);
    scrollBottom.setViewportView(editorPane);
    //JSplitPane
    split.setOrientation(JSplitPane.VERTICAL_SPLIT);
    split.setTopComponent(scrollTop);
    split.setBottomComponent(scrollBottom);
    split.setOneTouchExpandable(true);
    split.setDividerLocation(100);
    split.setDividerSize(7);
  }
  public void addComponents(){
    frame.getContentPane().add(split);
    tree.addTreeSelectionListener(this);
  }
  public void addWidget(){
//    FrameCenterMove.setFrameCenterMove(frame);
  }
  public void viewUI(){
    frame.setVisible(true);
  }
  
  public DefaultMutableTreeNode getTree(){
    DefaultMutableTreeNode dmTree = new DefaultMutableTreeNode("Java Tree^^");
    createTreeNode(dmTree);
    
    return dmTree;
  }
  
  //create tree node
  private void createTreeNode(DefaultMutableTreeNode dmTree){
    DefaultMutableTreeNode sub1 = null;
    DefaultMutableTreeNode sub2 = null;
    
    sub1 = new DefaultMutableTreeNode("Java");
    for(int i=1; i<3; i++){
      String str  = "sub1_" + i;
      String name = "test" + i + ".html";
      DefaultMutableTreeNode dmtn = new DefaultMutableTreeNode(new InfoNode(str, name));
      sub1.add(dmtn);
    }
    
    sub2 = new DefaultMutableTreeNode("Swing");
    for(int i=3; i<5; i++){
      String str  = "sub2_" + i;
      String name = "test" + i + ".html";
      DefaultMutableTreeNode dmtn = new DefaultMutableTreeNode(new InfoNode(str, name)); 
      sub2.add(dmtn);
    }
     
    dmTree.add(sub1);
    dmTree.add(sub2);
  }
  
  //editorPane ο path  б
  public void valueChanged(TreeSelectionEvent e){
    DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
    if(node == null){ return; }
    if(node.isLeaf()){
      Object nodeObj = node.getUserObject();
      InfoNode infoNode = (InfoNode)nodeObj;
      try{ editorPane.setPage(infoNode.getPathURL()); }catch(IOException ie){ ie.getMessage(); }
    }
  }
  
  //get URL
  private class InfoNode{
   public String nameInfo;
   public URL pathURL;
   
   public InfoNode(String str, String name){
     nameInfo = str;
     pathURL  = test.class.getResource(name);
     if(pathURL == null){
       System.out.println("Couldn't find file: " + name);
     }
   }
   
   public URL getPathURL(){
     return pathURL;
   } 
   
   public String toString(){
     return nameInfo;
   }
   
  }//InfoNode class end
  
  /**
   * set Look And Feel 
   **/
  public static void setLAF(){
    try{
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }catch(Exception e){
      System.err.println("Couldn't use system look and feel");
    } 
  }
  
  //Main Method
  public static void main(String[] args){
    SwingUtilities.invokeLater(new Runnable(){
      public void run(){
        setLAF();
        new test();
      }
    });
  }//main() end
}//


