package com.Exception.cl;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetSocketAddress;
import java.net.SocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.SocketChannel;
import java.nio.charset.CharacterCodingException;
import java.nio.charset.Charset;
import java.nio.charset.CharsetDecoder;
import java.util.Iterator;

public class Client {

	private Selector selector = null;
	private SocketChannel sc = null;
	private Charset charset = null;
	private CharsetDecoder decoder = null;
	
	public Client(){
		charset = Charset.forName("EUC-KR");
		decoder = charset.newDecoder();
	}
	
	public void initServer(){
		try {
			
			selector = Selector.open();
			
			sc = SocketChannel.open(new InetSocketAddress("localhost",9090));
			
			sc.configureBlocking(false);
			
		} catch (IOException e) {
			System.out.println("   initServer() : "+e);
		}
	}
	
	public void startServer(){
		startWriter();
		startReader();
	}
	
	private void startWriter(){
		
		Thread t = new MyThread(sc);
		t.start();
		
	}
	
	private void startReader(){
		
		try {
			selector.select();
			
			Iterator it = selector.selectedKeys().iterator();
			while(it.hasNext()){
				SelectionKey key = (SelectionKey)it.next();
				if(key.isReadable()){
					read(key);
				}
				it.remove();
			}
		} catch (Exception e) {
			System.out.println("ŸƮ  ޼ҵ忡  : "+e);
		}
	}
	
	private void read(SelectionKey key){
		
		SocketChannel sc =(SocketChannel)key.channel();
		ByteBuffer buffer = ByteBuffer.allocateDirect(1024);
		int read = 0;
		try {
			
			read = sc.read(buffer);
			info(read+"byte оϴ.");
		} catch (IOException e) {
			try {
				System.out.println("read ޼ҵ忡 д  ߻ : "+e);
				sc.close();
			} catch (IOException e1) {
				System.out.println("read޼ҵ忡  ä ݴ  ߻ : "+e1);
			}
		}
		buffer.flip();
		
		String data = "";
		
		try {
			data = decoder.decode(buffer).toString();
		} catch (CharacterCodingException e) {
			System.out.println("ڵ  ߻ : "+ e);
		}
		
		System.out.println("Message - "+data);
		clearBuffer(buffer);
	}
	public void info(String msg){
		System.out.println("msg");
	}
	
	
	class MyThread extends Thread{
		private SocketChannel sc = null;
		
		public MyThread(SocketChannel sc){
			this.sc = sc;
		}
		
		public void run(){
			ByteBuffer buffer = ByteBuffer.allocateDirect(1024);
			try {
				while(!Thread.currentThread().isInterrupted()){
					buffer.clear();
					BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
					String message = in.readLine();
					if(message.equals("quit")||message.equals("shutdown")){
						System.exit(0);
					}
					
					buffer.put(message.getBytes());
					buffer.flip();
					
					sc.write(buffer);
				}
			} catch (Exception e) {
				System.out.println("  ޼ҵ忡  : "+e);
			} finally {
				clearBuffer(buffer);
			}
		}
	}

	public void clearBuffer(ByteBuffer buffer){
		if(buffer != null){
			buffer.clear();
			buffer = null;
		}
	}
	
	
	public static void main(String[] args) {
		Client c = new Client();
		c.initServer();
		c.startServer();
	}
}
