package com.Exception.server;

import java.security.MessageDigest;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Locale;
import java.util.Properties;
import java.util.Vector;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.SendFailedException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeUtility;

import com.Exception.GUIKey.ProtocolKey;
import com.Exception.dbcon.DbCon;

public class ServerManager {
	private Connection con = null;
	private PreparedStatement pstmt = null;
	private ResultSet rs = null;
	private String query = null;
	private DbCon dbcon = new DbCon();
	
	public ServerManager(){} 
	
	// μ 
	public Vector allDivision(){
		con = dbcon.getConnection();
		query = "select div_name from division";
		Vector v = new Vector();
		try {
			pstmt = con.prepareStatement(query);
			rs = pstmt.executeQuery();
			while(rs.next()){
				v.add(rs.getString("div_name"));
			}
		} catch (SQLException e) {
			System.out.println("ServerManager allDivision : "+e);
		}
		return v;
	}
	
	//  ϱ
	public ArrayList allUser(){
		con = dbcon.getConnection();
		query = "select emp_id,emp_name,emp_division,emp_position from employee";
		
		ArrayList al = new ArrayList(); 
		try{
			pstmt = con.prepareStatement(query);
			rs = pstmt.executeQuery();
			while (rs.next()){
				MemElement me = new MemElement();
				me.setEmp_id(rs.getString("emp_id"));
				me.setEmp_name(rs.getString("emp_name"));
				me.setEmp_division(rs.getString("emp_division"));
				me.setEmp_position(rs.getString("emp_position"));
				al.add(me);
			}
		}catch (SQLException e) {
			end(rs,pstmt,con);
		}
		return al;
	}
	
	// ,  ,  
	public Vector init(String id){
		Vector v = new Vector();
		con = dbcon.getConnection();
		int note=0,mail=0,appr = 0;
		try {
			// 
			query = "SELECT * FROM note where note_host = ? and note_confirm= false";
			pstmt = con.prepareStatement(query);
			pstmt.setString(1,id);
			rs = pstmt.executeQuery();
			if(rs.next()){
				rs.last();
				note=rs.getRow();
				System.out.println("  : "+ note);
			}
			// 
			query = "SELECT * FROM mail where  mail_host = ? and mail_confirm= false";
			pstmt = con.prepareStatement(query);
			pstmt.setString(1,id);
			rs = pstmt.executeQuery();
			if(rs.next()){
				rs.last();
				mail=rs.getRow();
				System.out.println("  : "+ mail);
			}
			//缭 
			query = "SELECT * FROM approval_per where appr_per_per = ? and appr_per_confirm= false";
			pstmt = con.prepareStatement(query);
			pstmt.setString(1,id);
			rs = pstmt.executeQuery();
			if(rs.next()){
				rs.last();
				appr=rs.getRow();
			}
			System.out.println("   : "+ appr);
			v.add(new Integer(note));
			v.add(new Integer(mail));
			v.add(new Integer(appr));
		} catch (SQLException e) {
			System.out.println("ServerManager init(String id) error : "+e);
		}
		return v;
	}
	 
	// ¥,,ε ȣ
	public Vector notice(){
		con = dbcon.getConnection();
		Vector v = new Vector();
		try {
			query = "SELECT notice_date, notice_title, notice_seq from notice order by notice_seq desc limit 5;";
			pstmt = con.prepareStatement(query);
			rs = pstmt.executeQuery();
			
			while (rs.next()){
				v.add(rs.getString("notice_date"));
				v.add(rs.getString("notice_title"));
				v.add(new Integer((rs.getInt("notice_seq"))));
			}
		}catch (SQLException e) {
			System.out.println("ServerManager notice() error : "+e);
		}
		return v;
	}
	
	// α
	public MemElement login(MemElement me){
		String pw = me.getEmp_pw();
		query = "SELECT * FROM employee where emp_id = ?";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			pstmt.setString(1,me.getEmp_id());
			rs = pstmt.executeQuery();
			if(rs.next()){
				//̵ ִ.
				if(encryptString(pw).equals(rs.getString("emp_pw"))){
					//α 
					me.setEmp_pw(rs.getString("emp_pw"));
					me.setEmp_seq(rs.getInt("emp_seq"));
					me.setEmp_name(rs.getString("emp_name"));
					me.setEmp_position(rs.getString("emp_position"));
					me.setEmp_safe(rs.getString("emp_safe"));
					me.setEmp_division(rs.getString("emp_division"));
					me.setEmp_salary(rs.getString("emp_salary"));
					query = "SELECT com_seq, com_start, com_end, com_date FROM commute where com_seq = ? and com_date = ?";
					pstmt = con.prepareStatement(query);
					pstmt.setInt(1,me.getEmp_seq());
					pstmt.setString(2,today());
					rs = pstmt.executeQuery();
					if(!rs.next()){
						query = "INSERT INTO commute(com_seq, com_start, com_end, com_date) VALUES (?, ?, ?, ?)";
						pstmt = con.prepareStatement(query);
						pstmt.setInt(1,me.getEmp_seq());
						pstmt.setString(2,now());
						pstmt.setString(3,now());
						pstmt.setString(4,today());
						pstmt.executeUpdate();
					}
					me.setKey(ProtocolKey.loginOk);
				}else{
					//йȣ 
					me.setKey(ProtocolKey.nopw);
				}
			}else{
				//id .
				me.setKey(ProtocolKey.noId);
			}
			
		}catch(Exception e){
			System.out.println("ServerManager login error : "+e.toString());
		}
		finally{
			end(rs,pstmt,con);
		}
		return me;
	}
	
	// īװ 
	public void doc_category(){
		
	}
	
	// 
	public Vector schedule(Vector v){
		con = dbcon.getConnection();
		Vector vv = new Vector();
		try {
			query ="select plan_host, plan_date, plan_content from plan where plan_host = ? and plan_date = ?";
			pstmt = con.prepareStatement(query);
			pstmt.setString(1,(String)v.get(1));
			pstmt.setString(1,(String)v.get(2));
			rs = pstmt.executeQuery();
			while(rs.next()){
				vv.add(rs.getString("plan_host"));
				vv.add(rs.getString("plan_date"));
				vv.add(rs.getString("plan_content"));
			}
		} catch (SQLException e) {
			System.out.println("ServerManager scheduleSave() error : "+e);
		} finally{
			end(rs,pstmt,con);
			return vv;
		}
	}
	
	
	// 
	public void scheduleSave(Vector v){
		con = dbcon.getConnection();
		query = 
			"INSERT INTO plan(plan_host, plan_date, plan_content) VALUES (?, ?, ?);";
		try {
			pstmt = con.prepareStatement(query);
			pstmt.setString(1,(String)v.get(1));
			pstmt.setString(2,today());
			pstmt.setString(3,(String)v.get(2));
			pstmt.executeUpdate();
		} catch (SQLException e) {
			System.out.println("ServerManager scheduleSave() error : "+e);
		} finally{
			end(rs,pstmt,con);
		}
	}

	//ȣȭ ޼ҵ
	public String encryptString(String str) {
        StringBuffer sb = new StringBuffer();
        int i;
        try{
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            md5.update(str.getBytes());
            byte[] md5Bytes = md5.digest(); 
            for( i = 0 ; i < md5Bytes.length ; i++){
                sb.append(md5Bytes[i]);
            }
        } catch (Exception e) {
        }
        return sb.toString();
    }
	
	// ¥ ϱ
	public String today(){
		SimpleDateFormat formatter = new SimpleDateFormat ("yyyy-MM-dd", Locale.KOREA );
		Date currentTime = new Date();
		String dTime = formatter.format (currentTime);
		System.out.println(dTime);
		return dTime;
	}
	
	//ð ϱ 
	public String now(){
		SimpleDateFormat formatter = new SimpleDateFormat ("HH:mm:ss", Locale.KOREA );
		Date currentTime = new Date ();
		String dTime = formatter.format (currentTime);
		System.out.println(dTime);
		return dTime;
	}
	
	// ϱ
	public MemElement exit(MemElement me){
		
		query = "UPDATE commute SET com_end= ? WHERE com_seq = (select emp_seq from employee where emp_id = ?);";
		try{
			con = dbcon.getConnection();
			
			pstmt = con.prepareStatement(query);
			pstmt.setString(1,now());
			pstmt.setString(2,me.getEmp_id());
			int i = pstmt.executeUpdate();
			me.setKey(ProtocolKey.outOk);
			System.out.println("α׾ƿ  ϱ Ʈ  : "+ i);
		}catch(Exception e){
			System.out.println("ServerManager {{{ exit method error : "+e.toString());
			me.setKey(ProtocolKey.outFail);
		}
		finally{
			end(rs,pstmt,con);
		}
		return me;
	}
	
	// DB 
	public Vector note(Vector v){
		Vector index = new Vector();
		try {
			con = dbcon.getConnection();
			query = 
				"INSERT INTO note("+
			            "note_index, note_host, note_to, note_from, note_content, note_confirm,"+ 
			            "note_box, note_date)"+
			    "VALUES (?, ?, ?, ?, ?, ?, ?, ?)";
			pstmt = con.prepareStatement(query);
			int i = getNoteSeq("note");
			pstmt.setInt(1,i);
			pstmt.setString(2,(String)v.get(1));
			pstmt.setString(3,(String)v.get(1));
			pstmt.setString(4,(String)v.get(2));
			pstmt.setString(5,(String)v.get(3));
			pstmt.setBoolean(6,false);
			pstmt.setInt(7,0);
			pstmt.setString(8,today()+" "+now());
			pstmt.executeUpdate();
			index.add(new Integer(i));
			if(ProtocolKey.noteSaveSend==((Integer)v.get(0)).intValue()){
				int i2 = getNoteSeq("note");
				pstmt = con.prepareStatement(query);
				pstmt.setInt(1,i2);
				pstmt.setString(2,(String)v.get(2));
				pstmt.setString(3,(String)v.get(1));
				pstmt.setString(4,(String)v.get(2));
				pstmt.setString(5,(String)v.get(3));
				pstmt.setBoolean(6,false);
				pstmt.setInt(7,0);
				pstmt.setString(8,today()+" "+now());
				pstmt.executeUpdate();
				index.add(new Integer(i2));
			}
			
		} catch (SQLException e) {
			System.out.println("ServerManager {{{ note method error : "+e.toString());
		}finally{
			end(rs,pstmt,con);
			return index;
		}
	}
	
	// DB 
	public void noteDel(Vector v){
		int i = ((Integer)v.get(2)).intValue();
		con = dbcon.getConnection();
		String qurey = "Delete from note where note_seq = ?";
		try {
			pstmt = con.prepareStatement(qurey);
			pstmt.setInt(1,i);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			System.out.println("ServerManager noteDel method : "+e);
		}
	}
	
	//  ̵ ϱ
	public void noteMove(Vector v){

		query = "UPDATE note SET note_box = ? WHERE note_seq = ?);";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			pstmt.setInt(1,((Integer)v.get(2)).intValue());
			pstmt.setInt(2,((Integer)v.get(1)).intValue());
			int i = pstmt.executeUpdate();
		}catch(Exception e){
			System.out.println("ServerManager {{{ exit method error : "+e.toString());
		}
		finally{
			end(rs,pstmt,con);
		}
	}
	
	//  û
	public Vector noteBox(Vector v){
		con = dbcon.getConnection();
		query = "SELECT note_index, note_host, note_to, note_from, note_content, note_confirm,"+ 
	       "note_box, note_date FROM note where note_host = ?";
		Vector noteBox = new Vector();
		try{
			pstmt = con.prepareStatement(query);
			pstmt.setString(1,((String)v.get(1)));
			rs = pstmt.executeQuery();
			while (rs.next()){
				rs.getInt("note_index");
				noteBox.add(rs.getString("note_host"));
				noteBox.add(rs.getString("note_to"));
				noteBox.add(rs.getString("note_from"));
				noteBox.add(rs.getString("note_content"));
				noteBox.add(new Boolean(rs.getBoolean("note_confirm")));
				noteBox.add(new Integer(rs.getInt("note_box")));
				noteBox.add(rs.getString("note_date"));
			}
		}catch (SQLException e) {
			end(rs,pstmt,con);
		}
		return noteBox;
	}
	
	// Ȯ 
	public void noteOk(Vector v){
		Vector index = (Vector)v.get(2);
		query = "UPDATE note SET note_confirm = true WHERE note_index = ?";
		
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			pstmt.setInt(1,((Integer)index.get(0)).intValue());
			pstmt.executeUpdate();
			if(v.size()==2){
				pstmt.setInt(1,((Integer)v.get(1)).intValue());
				pstmt.executeUpdate();
			}
		}catch(Exception e){
			System.out.println("ServerManager noteOk error : "+e.toString());
		}finally{
			end(rs,pstmt,con);
		} 
	}

	//ε  ϱ
	public int getNoteSeq(String table){
		int num = 0;
		query = "select max(note_index) from "+table;
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			rs = pstmt.executeQuery();
			if(rs.next()){
				num = rs.getInt(1)+1;
			}
		}catch(Exception e){
			System.out.println("ServerManager getNoticeSeq error : "+e.toString());
		}finally{
			end(rs,pstmt,con);
		} 
		return num;
	}
	
	//  
	public int mailSend(Vector v){
		//,, ,   
		int i=mailSend((String)v.get(1),(String)v.get(1),(String)v.get(2),(String)v.get(3),(String)v.get(4));
		switch (i) {
		case 2:
			
			break;
		}
		return i;
	}
	
	public int mailSend 
	(String from, String to ,String subject,
			String content,String filename) {
		int i=0;
		String host = "58.227.54.250";
		try {
			
			Properties props = System.getProperties();

			props.put("mail.smtp.host", host);
			Session session = Session.getInstance(props, null);
			Message message = new MimeMessage(session);
			
			message.setFrom(new InternetAddress(from));
			message.addRecipient(Message.RecipientType.TO, new InternetAddress(to));
			message.setSubject(subject);
			message.setSentDate(new Date());

			if(filename==null||filename.equals("")){
				message.setText(content);
			}else{

				BodyPart messageBodyPart = new MimeBodyPart();

				messageBodyPart.setText(content);

				Multipart multipart = new MimeMultipart();

				multipart.addBodyPart(messageBodyPart);

				messageBodyPart = new MimeBodyPart();

				DataSource source = new FileDataSource(filename);
				messageBodyPart.setDataHandler(new DataHandler(source));
				
				String tempName = 
					MimeUtility.encodeText
					(source.getName(), "KSC5601", "Q");
				messageBodyPart.setFileName(tempName);
				messageBodyPart.setFileName(source.getName());

				multipart.addBodyPart(messageBodyPart);
				message.setContent(multipart);
			}
			Transport.send(message);
			
		}catch (AddressException e) {
			e.printStackTrace();
			i=1;
		}catch (SendFailedException e) {
			e.printStackTrace();
			i=2;
		}catch(Exception e) {
			e.printStackTrace();
		}finally{
			return i;
		}
	}
	
	//̳θ ߺ  ó 
	private void end(ResultSet rs,PreparedStatement pstmt, Connection con){
		try{
			if(rs!=null)rs.close();
		}catch(Exception e){
			System.out.println(e.getStackTrace());
		}
		
		try{
			if(pstmt!=null)pstmt.close();
		}catch(Exception e){
			System.out.println(e.getStackTrace());
		}
		try{
			if(con!=null)con.close();
		}catch(Exception e){
			System.out.println(e.getStackTrace());
		}
	}
}
