package com.itbc.lucene;

import java.io.BufferedReader;
import java.io.File; 
import java.io.FileReader;
import java.io.IOException; 

import org.apache.lucene.analysis.Token;
import org.apache.lucene.analysis.TokenFilter;
import org.apache.lucene.analysis.TokenStream;

public class KoreanStemFilter extends TokenFilter {

	/*
	 * ߶  ̴.   ̸ óϷ ⿡ ϴ ŭ ߰.
	 */ 
	private static  String[] WORD_ENDING = null;

	private TokenStream stream = null;

	/**
	 * ⺻  ޼ҵ.
	 */
	public KoreanStemFilter(TokenStream input ,String path) {
		super(input);
		stream = input;
		getWord_ending(path);
	}
	//
	public void getWord_ending(String path){
		FileReader fr = null;
		BufferedReader br =null;
		try{
			// Ͽ б   Ʈ Ѵ.
	
			 fr = new FileReader( new File( path+"/WEB-INF/data/sch_word_ending.txt" ) );
			 br = new BufferedReader( fr );
			String all_read="";
			String s = "";
			while((s=br.readLine())!=null){
				all_read +=s;
	        } 
			
			WORD_ENDING = all_read.split(",");// ,  
		}catch(Exception e){
			e.printStackTrace();
		}finally{
			try{
			br.close();
			fr.close();
			}catch(Exception e){}
		
		}

	}
	/*
	 *  ó ū ̾ش. ⿡ stem() ޼ҵ带 ȣ ̸ ߶󳻰,   ٽ
	 * ū  Ѵ.  ġ,  ġ, ġ ״ Ѵٴ  .
	 */
	public Token next() throws IOException {

		Token token = stream.next();
		if ( token == null ) {
			/*
			 * End of Stream.  ̻ ó ū .
			 */
			return null;
		}

		/*
		 * startOffset, endOffset, type, positionIncrement 
		 * ū  ״ Ѵ.
		 */
		Token result = new Token( stem( token.termText() ),
				token.startOffset(),
				token.endOffset(),
				token.type() );
		result.setPositionIncrement( token.getPositionIncrement() );

		return result;
	}

	/**
	 * ˷   WORD_ENDING ־ ܾ term ؼ, ´   
	 * ڼ  ̸ ãƳ, term ش ̸   Ѵ.
	 */
	private String stem( String term ) {

		int longestWordEndingLength = 0;
		int longestWordEndingId = -1;

	 
		for ( int i = 0; i < WORD_ENDING.length; i++ ) {
			if ( term.endsWith( WORD_ENDING[ i ] ) ) {
				longestWordEndingLength = WORD_ENDING[ i ].length();
				longestWordEndingId = i;
			}
		}

		if ( longestWordEndingLength == 0 || longestWordEndingId == -1 ) {
			/*
			 * ´ ̰   ܾ ״ Ѵ.
			 */
			return term;
		}

		/*
		 * ܾ ڿ  ̸ŭ ߶󳻰  κи Ѵ.
		 */
		return term.substring( 0, term.length() - longestWordEndingLength );
	}
}
