package com.itbc.lucene;

import java.io.IOException; 
 
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.itbc.util.Command;



import java.util.ArrayList;

public class LuceneControl implements Command{

	private static final long serialVersionUID = 1L;
	private HttpServletRequest request;
	private HttpServletResponse response;
	private SearchEngine sengine;
	private LuceneManager manager;
	private String resultPage="";	

	
	
	public String Execute(HttpServletRequest request,HttpServletResponse response){

		this.request = request;
		this.response = response;	
		
		this.response.setHeader("Cache-control","no-cache");
		
      
		try{  
			request.setCharacterEncoding("EUC-KR"); 
			
			String mode = request.getParameter("mode")!=null
			?request.getParameter("mode"):"indexer";
			
//			String path2 = request.getSession().getServletContext().getRealPath("");
//			String path = request.getRealPath("");
			String path = (String)request.getAttribute("path");
			System.out.println("realPath : "+path);
			sengine = new SearchEngine(path,"\\search\\index");
			manager = new LuceneManager();
			
			if(mode.equals("indexer")){//ε ʱȭ
				System.out.println("indexer");
				indexer(path);
				request.setAttribute("bodyPage","/notice/notice_allList.jsp");
				resultPage="/notice.do?mode=nAllList";
			}else if(mode.equals("search")){
				
				String query = request.getParameter("searchText");
				String type = request.getParameter("searchType");
				int page = Integer.parseInt(request.getParameter("page"));
				
				System.out.println("lucene Search page : "+page);
				request.setAttribute("list",search(query,type,page));
				
				int totalCount = sengine.getSearch_totalCount();

				
				
				request.setAttribute("count",new Integer(totalCount));
				request.setAttribute("pageNav",getPageNav(page,totalCount));
				request.setAttribute("bodyPage","/body/notice/notice_search.jsp");
				request.setAttribute("type",type);
				request.setAttribute("searchWord",query);
				resultPage="/main/main.jsp";
			}else if(mode.equals("search_page")){//page ˻
			}
			
			
			/*RequestDispatcher view = request.getRequestDispatcher(resultPage);
			view.forward(request,response);		
*/
		}catch(Exception e){			
			System.out.println("luceneError 222: "+e.toString());
		}
		return resultPage;
	}
	 
	public void indexer(String path){
		
		try{
			System.out.println("path : "+path);
			IndexEngine  iengine = new IndexEngine(path);
			iengine.setIndexFolder(path+"/search/index");
			iengine.reorgainze();
		}catch(Exception e){
			System.out.println("indexer()error : "+e.toString());
		}
	}
	public ArrayList search(String query,String type, int page ){
		ArrayList list = new ArrayList();
		

		try{ 
			list = sengine.search_page(query,type,page);
			
		}catch(Exception e){
			e.printStackTrace();
			//goError("Ʈ  : "+ sch +e.getMessage());
		}
		return list;
	}

	public ArrayList wordlist(){
		
		ArrayList list = new ArrayList();
		try{
			list = manager.getWordList();
		}catch(Exception e){
			goError("Ʈ  : "+e.getMessage());
		}
		return list;
	}

	
	public String queryinsert(String state){

		String result="";
		 
		try{
			if(state.equals("C")){//ü˻
				String query = request.getParameter("content");	
				if(query!=null && !query.equals(""))
					result = manager.queryinsert(query);
			}
		}catch(Exception e){
			e.printStackTrace();		
		}
		return result;
			
	}	

	public StringBuffer getPageNav(int page,int totalCount){
		StringBuffer pageNav = new StringBuffer();
		
		int pageSize=5; //   Խù 
		int pageCount = (int)Math.ceil(totalCount/(pageSize+0.0));		//ü 
		int groupSize=5; //    
		int curGroup = (page-1)/groupSize;
		int linkPage =curGroup*groupSize;
		
		if(curGroup>0){
			pageNav.append("<a href='#'  onClick=\"page_submit('search','");
			pageNav.append((curGroup-1)*pageSize+1);
			pageNav.append("')\"><img src='/images/btn_prev.gif' border=0 align='absmiddle'></a>&nbsp;&nbsp;");
		}
		while((groupSize>0) && (linkPage<pageCount)){

			linkPage++;
			groupSize--;
			if(page==linkPage){
				pageNav.append("<font color='red'>"+linkPage+"</font>");
				pageNav.append("&nbsp;&nbsp;");
			}else{
				pageNav.append("<a href='#'  onClick=\"page_submit('search','"+linkPage+"')\">");
				pageNav.append(linkPage);
				pageNav.append("</a>&nbsp;&nbsp;");
			}
		}
		
		if(linkPage<pageCount){
			pageNav.append("<a href='#'  onClick=\"page_submit('search','");
			pageNav.append(linkPage+1);
			pageNav.append("')\"><img src='/images/btn_next.gif' border=0 align='absmiddle'></a>");
		}
		return pageNav;
		
	}
	

	
	// ̵
	private void goError(String error){

		try{
			request.setAttribute("error",error);
			RequestDispatcher view = request.getRequestDispatcher("/error.jsp");
			view.forward(request,response);
		}catch(Exception ex){
			ex.printStackTrace();
		}
	
	}

}


