package com.itbc.lucene;

import java.util.ArrayList;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.document.Document;

import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.BooleanQuery;
import org.apache.lucene.search.Sort;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.search.BooleanClause;
import org.apache.lucene.queryParser.*;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.itbc.Element.*;
public class SearchEngine {
	private String indexFolder = null;
	private Analyzer analyzer = null;
	private int search_totalCount ; 	//ü Խù

	public SearchEngine(String root,String filepath) {
		indexFolder =  root+filepath;
		analyzer = new KoreanAnalyzer(root);//new StandardAnalyzer();
	}
 
	public ArrayList search_page
	(String queryString, String type,int page) throws Exception {
	System.out.println(queryString+" : "+type+" : "+page);
		Directory directory = null;
		IndexSearcher searcher = null;
		ArrayList list = null;
		
		try { 

			int start = 5*(page-1);
			int end = 5*(page-1)+5;
 
			System.out.println("folder : "+indexFolder);
			directory = FSDirectory.getDirectory(indexFolder, false);
			searcher = new IndexSearcher(directory);//title:"The Right Way" AND text:go Ǵ title:"Do it right" AND right 
			
			
			Hits hits=null;
			BooleanQuery booleanQuery = new BooleanQuery();

			if(type.equals("2")){
				
				QueryParser parser = new QueryParser("content", analyzer);
				Query query = parser.parse(queryString);

				System.out.println("content : "+query);
//				TermQuery board_id = new TermQuery(new Term("board_id", board_id_));
//				booleanQuery.add(board_id, BooleanClause.Occur.MUST);
				booleanQuery.add(query, BooleanClause.Occur.MUST);
	
				System.out.println("booleanQuery 2 : "+booleanQuery);
				hits = searcher.search(booleanQuery, new Sort("seq"));
				System.out.println("title 2 : "+hits);
			}else if(type.equals("1")){
				
				QueryParser parser = new QueryParser("title", analyzer);
				Query query = parser.parse(queryString);
				System.out.println("content : "+query);
				
				booleanQuery.add(query, BooleanClause.Occur.MUST);
	
				System.out.println("booleanQuery 1 : "+booleanQuery);
				hits = searcher.search(booleanQuery);//, new Sort("notice_seq"));
				System.out.println("title 1 hits.length() : "+hits.length());
			}else if(type.equals("3")){
//				QueryParser parser = new QueryParser("title", analyzer);
//				QueryParser parser1 = new QueryParser("content", analyzer);
//				Query query = parser.parse(queryString);
//				Query query1 = parser1.parse(queryString);
				
				System.out.println("3");
				String[] fields = {"title","content"};
				System.out.println("or : "+fields.toString());
				
				BooleanClause.Occur[] flags = {BooleanClause.Occur.SHOULD,
						BooleanClause.Occur.SHOULD};

				Query query3 = MultiFieldQueryParser.parse(queryString,fields,flags,analyzer);
//				booleanQuery.add(query, BooleanClause.Occur.MUST);
//				booleanQuery.add(query1, BooleanClause.Occur.MUST);
				booleanQuery.add(query3, BooleanClause.Occur.MUST);
				System.out.println("booleanQuery 3 : "+booleanQuery);
				hits = searcher.search(booleanQuery, new Sort("seq"));
				System.out.println("title 3 : "+hits);
			}else {
//				QueryParser parser = new QueryParser("title", analyzer);
//				QueryParser parser1 = new QueryParser("content", analyzer);
//				Query query = parser.parse(queryString);
//				Query query1 = parser1.parse(queryString);
				
				
				String[] fields = {"title","content"};
				System.out.println("and : "+fields.toString());
				
				BooleanClause.Occur[] flags = {BooleanClause.Occur.MUST,
						BooleanClause.Occur.MUST};

				Query query3 = MultiFieldQueryParser.parse(queryString,fields,flags,analyzer);
//				booleanQuery.add(query, BooleanClause.Occur.MUST);
//				booleanQuery.add(query1, BooleanClause.Occur.MUST);
				booleanQuery.add(query3, BooleanClause.Occur.MUST);
				System.out.println("booleanQuery else : "+booleanQuery);
				hits = searcher.search(booleanQuery, new Sort("seq"));
				System.out.println("title else : "+hits);
			}
			search_totalCount=hits.length(); 
			System.out.println("hits.length : "+search_totalCount);
			if (hits.length() > 0) {
				list = new ArrayList(hits.length());
				Document document = null;
				for (int i = start; i < end; i++) {
					if(hits.length()==i){
						break;
					}
					document = hits.doc(i);
					NoticeElement bean = new  NoticeElement();
					String temp = null;
//					bean.setId(Integer.parseInt(document.get("id")));
					bean.setNotice_title(markKeyword(getStr(document.get("title")),queryString));
					
					temp = getStr(document.get("content"));
					int startnum = temp.indexOf(queryString);
					int totalnum = temp.length();
					int endnum = totalnum - startnum;
					
					if(startnum>-1){
						if(endnum>50){
							bean.setNotice_content(markKeyword(temp.substring(startnum, startnum+50)+" .....",queryString));
						}else{
							bean.setNotice_content(markKeyword(temp.substring(startnum)+" .....",queryString));
	 					}
					}else{
						if(totalnum>50){
							bean.setNotice_content(temp.substring(0,50)+" .....");
						}else{
							bean.setNotice_content(temp.substring(0)+" .....");
						}
					}

					bean.setNotice_division(document.get("division"));
					bean.setNotice_seq( Integer.parseInt(document.get("seq")));
//					bean.setRegDate(document.get("regDate"));
//					bean.setSmallImage(document.get("smallImage"));
					list.add(bean);
					document = null;
					
				}
			}
		} catch (Exception e) {
			System.out.println("seError : "+e.toString());
//			throw exception;
		} finally {
			if (searcher != null) try { searcher.close(); } catch (Exception exception) {}
			if (directory != null) try { directory.close(); } catch (Exception exception) {}
		}
		System.out.println("re list : "+list);
		return list;
	}
	
	
	
	 
    public static String markKeyword(String str, String keyword) {
 
        keyword =
        	replace(replace(replace
        			(replace(keyword, "[", "\\["), ")", "\\)"),"(", "\\("),
        			"&ltBR&gt","<P>");
 
        Pattern p = Pattern.compile( keyword , Pattern.CASE_INSENSITIVE );
        Matcher m = p.matcher( str );
        int start = 0;
        int lastEnd = 0;
        StringBuffer sbuf = new StringBuffer();
        while( m.find() ) {
            start = m.start();
            sbuf.append( str.substring(lastEnd, start) )
                .append("<font  color='red'  ><B>"+m.group()+"</B></font>" );
            lastEnd = m.end();
        } 
        return sbuf.append(str.substring(lastEnd)).toString() ;
    }
     
    public static String replace(String str, String oldStr, String newStr) {

        if (str == null) {
            return null;
        }
        if (oldStr == null || newStr == null || oldStr.length() == 0) {
            return str;
        }

        int i = str.lastIndexOf(oldStr);
        if (i < 0)
            return str;

        StringBuffer sbuf = new StringBuffer(str);

        while (i >= 0) {
            sbuf.replace(i, (i + oldStr.length()), newStr);
            i = str.lastIndexOf(oldStr, i - 1);
        }
        return sbuf.toString();
    }



	 
	
    public String getStr(String body){

    	Pattern p = Pattern.compile("\\<(\\/?)(\\w+)*([^<>]*)>");
    	Matcher m = p.matcher(body);
    	body = m.replaceAll("");
    	
    	return body;
    } 	
	
	public int getSearch_totalCount() {
		return search_totalCount;
	}

	public void setSearch_totalCount(int search_totalCount) {
		this.search_totalCount = search_totalCount;
	}


}
