package com.itbc.manager;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;

import com.itbc.Element.Element;
import com.itbc.dbCon.DbConnection;
import com.itbc.util.ChangeToBrTag;
import com.itbc.Element.*;


public class NoticeManager {
	private int pageSize ;	//   Խù 
	private int groupSize1;	//    
	private int page ;			//û 
	private int totalCount ; 	//ü Խù
	private int pageCount ;		//ü 
	
	public NoticeManager(){
		pageSize = 5 ;
		groupSize1= 5 ;
		
	}
	public NoticeManager(int pageSize, int groupSize1){
		this.pageSize = pageSize ;
		this.groupSize1 = groupSize1;
		
	}
	
	
	
public ArrayList getSearchList(String searchType, String searchText){
		System.out.println("getSearchList OK!!!");
		ArrayList list = new ArrayList();
		DbConnection dbCon = new DbConnection();
		String str ;
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		
//		<option value="1"></option>
//		<option value="2"></option>
//		<option value="3"> or </option>
//		<option value="4"> and </option>
		
		String sch = null;
		if(searchType.equals("1")){
			System.out.println("getSearchList : "+searchType);
			sch = " notice_title like '%"+searchText+"%'";
		}else if(searchType.equals("2")){
			System.out.println("getSearchList : "+searchType);
			sch = "notice_content like '%"+searchText+"%'";
			
		}else if(searchType.equals("3")){
			System.out.println("getSearchList : "+searchType);
			sch = " notice_title like '%"+searchText+"%' or "+
			"notice_content like '%"+searchText+"%'";
			
		}else if(searchType.equals("4")){
			System.out.println("getSearchList : "+searchType);
			sch = " notice_title like '%"+searchText+"%' and "+
			"notice_content like '%"+searchText+"%'";
			
		}
		
		
		
		int count = pageSize*(page-1);
		str = "select * from notice where "+sch+" order by notice_date desc limit "+pageSize+" offset "+count;
		try{
			con = dbCon.getConnection();
			pstmt = con.prepareStatement(str);
			
			rs = pstmt.executeQuery();
			while(rs.next()){
				NoticeElement note = new NoticeElement();
				ChangeToBrTag chStr = new ChangeToBrTag();
				note.setNotice_seq(rs.getInt("notice_seq"));
				note.setNotice_title(rs.getString("notice_title"));
				note.setNotice_content(rs.getString("notice_content"));
				note.setNotice_division(rs.getString("notice_division"));
				note.setNotice_date(rs.getString("notice_date"));
				System.out.println("search len"+list.size());
				list.add(note);
			}
			str="select count(notice_seq) from notice where "+sch;
			pstmt = con.prepareStatement(str);
			rs = pstmt.executeQuery();
			if(rs.next()){
				totalCount = rs.getInt(1);
			}
			
			pageCount = (int)Math.ceil(totalCount/(pageSize+0.0));		//ü 
			
		}catch(Exception e){
			System.out.println("noteSearch error : "+e.toString());
		}
		finally{
			try{
				if(rs!=null)rs.close();
			}catch(Exception e){}
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}
		return list;
	}

	public ArrayList getList(){
		
		ArrayList list = new ArrayList();
		DbConnection dbCon = new DbConnection();
		String str ;
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		System.out.println();
		int count = pageSize*(page-1);
		str = "select * from notice order by notice_seq desc limit ? offset ?";
		
		
		try{
			
			con = dbCon.getConnection();
			pstmt = con.prepareStatement(str);
			pstmt.setInt(1,pageSize);
			pstmt.setInt(2,count);
			rs = pstmt.executeQuery();
			while(rs.next()){
				NoticeElement ne = new NoticeElement(rs.getString("notice_date"),rs.getString("notice_title"),rs.getString("notice_division"),rs.getString("notice_content"),rs.getInt("notice_seq"));
				
				list.add(ne);
				System.out.println(ne.getNotice_title());
			}
			str="select count(notice_seq) from notice  ";
			pstmt = con.prepareStatement(str);
			rs = pstmt.executeQuery();
			if(rs.next()){
				totalCount = rs.getInt(1);
			}
			
			pageCount = (int)Math.ceil(totalCount/(pageSize+0.0));		//ü 
			
		}catch(Exception e){
			System.out.println("list error : "+e.toString());
		}
		finally{
			try{
				if(rs!=null)rs.close();
			}catch(Exception e){}
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}
		return list;
	}
	
	public NoticeElement getRead(int seq){
		
		
		DbConnection dbCon = new DbConnection();
		String str = null;
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		NoticeElement note = null;
		str = "select * from notice where notice_seq = ?";
		ChangeToBrTag chStr = new ChangeToBrTag();
		
		try{
			
			con = dbCon.getConnection();
			pstmt = con.prepareStatement(str);
			pstmt.setInt(1,seq);
			
			rs = pstmt.executeQuery();
			while(rs.next()){
				note = new NoticeElement(rs.getString("notice_date"),rs.getString("notice_title"),rs.getString("notice_division"),(chStr.changeToBrTag(rs.getString("notice_content"))),rs.getInt("notice_seq"));
				
			}
			
		}catch(Exception e){
			System.out.println("read error : "+e.toString());
		}
		finally{
			try{
				if(rs!=null)rs.close();
			}catch(Exception e){}
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}
		return note;
	}
	public String noticeIns(NoticeElement note){
		
		
		DbConnection dbCon = new DbConnection();
		String str = null;
		Connection con = null;
		PreparedStatement pstmt = null;
		int index;
		
		str = "INSERT INTO notice(" +
				"notice_date, notice_title, notice_division, notice_content, notice_seq)" +
				" VALUES (?, ?, ?, ?, ?)";
		try{
			
			con = dbCon.getConnection();
			pstmt = con.prepareStatement(str);
			pstmt.setString(1,note.getNotice_date());
			pstmt.setString(2,note.getNotice_title());
			pstmt.setString(3,note.getNotice_division());
			pstmt.setString(4,note.getNotice_content());
			pstmt.setInt(5,note.getNotice_seq());
			
			index = pstmt.executeUpdate();
			if(index==0){
				str="ok";				
			}
			
			
			
		}catch(Exception e){
			System.out.println("read error : "+e.toString());
			str="err";
		}
		finally{
			
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}
		return str;
	}
	
	public StringBuffer getPageNav(String path){
		StringBuffer pageNav = new StringBuffer();
		int groupSize=groupSize1;
		int curGroup = (page-1)/groupSize;
		int linkPage =curGroup*groupSize;
		if(curGroup>0){
			pageNav.append("<a href=javascript:listView('");
			pageNav.append((curGroup-1)*pageSize+1);
			pageNav.append("')></a>&nbsp;&nbsp;");
		}
		while((groupSize>0) && (linkPage<pageCount)){

			linkPage++;
			System.out.println("linkPagepage : "+linkPage);
			groupSize--;
			if(page==linkPage){
				System.out.println("page OK : "+page);
				pageNav.append(linkPage);
				pageNav.append("&nbsp;&nbsp;");
			}else{
				System.out.println("page ELSE : "+page);
				pageNav.append("<a href=javascript:listView('");
				pageNav.append(linkPage);
				pageNav.append("') >&nbsp;&nbsp;");
				pageNav.append(linkPage);
				pageNav.append("</a>&nbsp;&nbsp;");
			}
		}
		
		if(linkPage<pageCount){
			pageNav.append("<a href=javascript:listView('");
			pageNav.append(linkPage+1);
			pageNav.append("')></a>&nbsp;&nbsp;");
		}
		return pageNav;
		
	}
	public int getNoteSeq(){
		DbConnection dbcon = new DbConnection();
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String query = null;
		int num = 0;
				query = "select max(notice_seq) from notice";
		try{
			con = dbcon.getConnection();
			pstmt = con.prepareStatement(query);
			
			rs = pstmt.executeQuery();
			if(rs.next()){
				num=rs.getInt(1);
				//System.out.println("num : "+num);
				//if(num!=0){
					//System.out.println("0! ok");
					num = num+1;
				//}else{
					
			//	}
			}
		}catch(Exception e){
			System.out.println("getNoticeSeq error : "+e.toString());
		}
		finally{
			try{
				if(rs!=null)rs.close();
			}catch(Exception e){}
			try{
				if(pstmt!=null)pstmt.close();
			}catch(Exception e){}
			try{
				if(con!=null)con.close();
			}catch(Exception e){}
		}	
		
		return num;
	}
	public void setPage(int page) {
		this.page = page;
	}
}
